"use strict";
//Dephormation
// 
//Licence Terms
// 
//1) Dephormation is copyright Peter John
//
//You may;
//
//2) Download and install Dephormation software for personal or commercial use
//
//3) You may use Dephormation software on as many computers as you wish, without charge
//
//4) You may decompile the software, but only to verify the code will perform to specification
//
//You may not;
//
//5) Rebrand or bundle the code, or any part of the code, with any other software product
//
//6) Incorporate the code into a product or service involving Phorm or any other advertising system
//
//Specific Restrictions;
//
//7) Dephormation software is not licenced for use by employees or sub-contractors working for Phorm, BT, Plusnet, TalkTalk, Virgin, Vodafone, BBC, News Corporation, News International, Logica, Experian, Verizon, Facebook, Schillings, Berenberg, Blackrock, Dartley Bank
//
//8) Dephormation software is not licenced for use by employees or sub-contractors working for UK Central Government (including but not limited to the Information Commissioners Office, Home Office, Ministry of Justice, Dept for Business Innovation and Skills, Cabinet Office, Ministry of Defence, Foreign Office, Department for Education).
//
//9) Dephormation software is not licenced for use by employees or sub-contractors working for UK Police forces
// 

var BrowserActivityLogFile = "Dephormation.log";

// functions to handle logfiles

function setBrowserActivityLogPath(){
      const nsIFilePicker = Components.interfaces.nsIFilePicker;
      const nsIPrefService = Components.interfaces.nsIPrefService;
      const nsIProperties = Components.interfaces.nsIProperties;
      const nsILocalFile = Components.interfaces.nsILocalFile;
      const nsIFile = Components.interfaces.nsIFile;
      
      // Get Users Home Folder
      var dirService = Components.classes["@mozilla.org/file/directory_service;1"].getService(nsIProperties); 
      var homeDirFile = dirService.get("Home", nsIFile); // returns an nsIFile object

      // Get existing preference if any for logging folder
      var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.dephormation.");

      if (!(prefs.prefHasUserValue("browserActivityLogPath")) )
      {
         initialiseBrowserActivityLogPath();
      }

      var defaultDirFile = prefs.getComplexValue("browserActivityLogPath", nsILocalFile);
      
      // Show the picker dialog
      var folderPicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
      folderPicker.init(window, "Dephormation Log Folder", nsIFilePicker.modeGetFolder);

      folderPicker.displayDirectory = defaultDirFile;

      var rv = folderPicker.show();
	
      if (rv == 0)
      {	
	   //Write path to prefs
		
	   prefs.setComplexValue("browserActivityLogPath", nsILocalFile, folderPicker.file);
      }
	
}

function logfile_output(logMessage){
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

	if (!(prefs.getBoolPref("enableBrowserActivityLog")))
         return;

      try {
         var logfile = prefs.getComplexValue("browserActivityLogPath", Components.interfaces.nsILocalFile);
         logfile.append(BrowserActivityLogFile);
	
         //create component for file writing
         var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
         file.initWithPath( logfile.path );

         // file is nsIFile, data is a string
         var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

         // write || create || append
         const PR_WRONLY      = 0x02;
         const PR_CREATE_FILE = 0x08; 	
         const PR_APPEND      = 0x10; 	
         const PR_IRWXU       = parseInt( "0700", 8);
         const PR_IRUSR       = parseInt( "0400", 8);
         const PR_IWUSR       = parseInt( "0200", 8);
         const PR_IRGRP       = parseInt( "0040", 8);
         const PR_IROTH       = parseInt( "0004", 8);

         foStream.init(file, PR_WRONLY | PR_CREATE_FILE | PR_APPEND, PR_IRUSR|PR_IWUSR|PR_IRGRP|PR_IROTH, 0); 

         var fileMessage = logMessage + "\n-------------------------------------------\n\n";

         foStream.write(fileMessage, fileMessage.length);

         foStream.flush();
      }
      catch(err) {
         dump("Dephormation: Warning, unable to write Logfile (usually caused by an incorrect logfile path, or file permission error.\n");
         dump(err.message);
         dump("\n");
      }
      foStream.close();
}

function initialiseBrowserActivityLogPath() {
   const nsIFile = Components.interfaces.nsIFile;
   const nsIPrefService = Components.interfaces.nsIPrefService;
   const nsILocalFile = Components.interfaces.nsILocalFile;
   const nsIEnvironment = Components.interfaces.nsIEnvironment;
   const nsIProperties = Components.interfaces.nsIProperties;
   
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.dephormation.");
	
   if (prefs.prefHasUserValue("browserActivityLogPath"))
      return;

   // HOME folder
   var dirService = Components.classes["@mozilla.org/file/directory_service;1"].getService(nsIProperties); 
   var homeDirFile = dirService.get("Home", nsIFile);

   var browserActivityLogPathFile = Components.classes["@mozilla.org/file/local;1"].createInstance(nsILocalFile);
   
   browserActivityLogPathFile.initWithPath( homeDirFile.path );
   
   prefs.setComplexValue("browserActivityLogPath", nsILocalFile, browserActivityLogPathFile );

}