"use strict";
//Dephormation
// 
//Licence Terms
// 
//1) Dephormation is copyright Peter John
//
//You may;
//
//2) Download and install Dephormation software for personal or commercial use
//
//3) You may use Dephormation software on as many computers as you wish, without charge
//
//4) You may decompile the software, but only to verify the code will perform to specification
//
//You may not;
//
//5) Rebrand or bundle the code, or any part of the code, with any other software product
//
//6) Incorporate the code into a product or service involving Phorm or any other advertising system
//
//Specific Restrictions;
//
//7) Dephormation software is not licenced for use by employees or sub-contractors working for Phorm, BT, Plusnet, TalkTalk, Virgin, Vodafone, BBC, News Corporation, News International, Logica, Experian, Verizon, Facebook, Schillings, Berenberg, Blackrock, Dartley Bank
//
//8) Dephormation software is not licenced for use by employees or sub-contractors working for UK Central Government (including but not limited to the Information Commissioners Office, Home Office, Ministry of Justice, Dept for Business Innovation and Skills, Cabinet Office, Ministry of Defence, Foreign Office, Department for Education).
//
//9) Dephormation software is not licenced for use by employees or sub-contractors working for UK Police forces
// 


// functions to handle lso files

// - LSO ---------------------------------------------------------------------------------------------------------------------------------------

function writePhormBRFlashLSO(uid){
   dump( "Dephormation: writePhormBRFlashLSO\n" );

   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;
   
   var LSOFileName             = prefs.getCharPref("PhormBRLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("PhormBRLSOFileSubPath");
         
   var LSORoot = "oix";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
   }
   LSOFields.push(LSOField);
   LSOField= { name: "ct",                value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}


function writePhormTRGezintiFlashLSO(uid){
   dump( "Dephormation: writePhormTRGezintiFlashLSO\n" );

   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   var LSOFileName             = prefs.getCharPref("PhormTRGezintiLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("PhormTRGezintiLSOFileSubPath");
         
   var LSORoot = "memo";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: "OPTED_OUT" };
       LSOFields.push(LSOField);
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: uid };
       LSOFields.push(LSOField);
   }
   LSOField= { name: "ct",                value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ct-firefox",        value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires-firefox", value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}


function writePhormTRAdoburFlashLSO(uid){
   dump( "Dephormation: writePhormTRAdoburFlashLSO\n" );

   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   var LSOFileName             = prefs.getCharPref("PhormTRAdoburLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("PhormTRAdoburLSOFileSubPath");
         
   var LSORoot = "memo";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: "OPTED_OUT" };
       LSOFields.push(LSOField);
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: uid };
       LSOFields.push(LSOField);
   }
   LSOField= { name: "ct",                value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ct-firefox",        value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires-firefox", value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}

function writePhormCNMooDooFlashLSO(uid){
   dump( "Dephormation: writePhormCNMooDooFlashLSO\n" );
   
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   var LSOFileName             = prefs.getCharPref("PhormCNMooDooLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("PhormCNMooDooLSOFileSubPath");
         
   var LSORoot = "memo";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: "OPTED_OUT" };
       LSOFields.push(LSOField);
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: uid };
       LSOFields.push(LSOField);
   }
   LSOField= { name: "ct",                value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ct-firefox",        value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires-firefox", value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}

function writePhormCNFengFengTieFlashLSO(uid){
   dump( "Dephormation: writePhormCNFengFengTieFlashLSO\n" );

   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   var LSOFileName             = prefs.getCharPref("PhormCNFengFengTieLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("PhormCNFengFengTieLSOFileSubPath");
         
   var LSORoot = "memo";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: "OPTED_OUT" };
       LSOFields.push(LSOField);
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: uid };
       LSOFields.push(LSOField);
   }
   LSOField= { name: "ct",                value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ct-firefox",        value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires-firefox", value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}

function writePhormCNGenniFlashLSO(uid){
   dump( "Dephormation: writePhormCNGenniFlashLSO\n" );
   
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   var LSOFileName             = prefs.getCharPref("PhormCNGenniLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("PhormCNGenniLSOFileSubPath");
         
   var LSORoot = "memo";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: "OPTED_OUT" };
       LSOFields.push(LSOField);
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: uid };
       LSOFields.push(LSOField);
   }
   LSOField= { name: "ct",                value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ct-firefox",        value: "DE-PHORMA-TION-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires-firefox", value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}

function writePhormRUIMRKFlashLSO(uid){
   dump( "Dephormation: writePhormRUIMRKFlashLSO\n" );

   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   var LSOFileName             = prefs.getCharPref("PhormRUIMRKLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("PhormRUIMRKLSOFileSubPath");
         
   var LSORoot = "memo";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: "OPTED_OUT" };
       LSOFields.push(LSOField);
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: uid };
       LSOFields.push(LSOField);
   }
   LSOField= { name: "ct",                value: "De-Phorm-atsiya:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ct-firefox",        value: "De-Phorm-atsiya:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires-firefox", value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}


function writePhorm__FideoFlashLSO(uid){
   dump( "Dephormation: writePhorm__FideoFlashLSO\n" );

   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   var LSOFileName             = prefs.getCharPref("Phorm__FideoLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("Phorm__FideoLSOFileSubPath");
         
   var LSORoot = "memo";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: "OPTED_OUT" };
       LSOFields.push(LSOField);
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: uid };
       LSOFields.push(LSOField);
   }
   LSOField= { name: "ct",                value: "De-fideo-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ct-firefox",        value: "De-fideo-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires-firefox", value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}


function writePhorm__PhluidMediaFlashLSO(uid){
   dump( "Dephormation: writePhorm__PhluidMediaFlashLSO\n" );

   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   var LSOFileName             = prefs.getCharPref("Phorm__PhluidMediaLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("Phorm__PhluidMediaLSOFileSubPath");
         
   var LSORoot = "memo";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: "OPTED_OUT" };
       LSOFields.push(LSOField);
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: uid };
       LSOFields.push(LSOField);
   }
   LSOField= { name: "ct",                value: "De-PhluidMedia-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ct-firefox",        value: "De-PhluidMedia-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires-firefox", value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}

function writePhorm__MooDooCNFlashLSO(uid){
   dump( "Dephormation: writePhorm__MooDooCNFlashLSO\n" );

   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   var LSOFileName             = prefs.getCharPref("Phorm__MooDooCNLSOFile");
   var LSOFileSubPath          = prefs.getCharPref("Phorm__MooDooCNLSOFileSubPath");
         
   var LSORoot = "memo";

   var LSOFields = new Array();
   var LSOField;
         
   if (prefs.getBoolPref("disablePhorm"))
   {
       LSOField= { name: "uid",               value: "OPTED_OUT" };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: "OPTED_OUT" };
       LSOFields.push(LSOField);
   }
   else if (prefs.getBoolPref("randomizePhormUID"))
   {
       LSOField= { name: "uid",               value: uid };
       LSOFields.push(LSOField);
       LSOField= { name: "uid-firefox",       value: uid };
       LSOFields.push(LSOField);
   }
   LSOField= { name: "ct",                value: "De-MooDooCN-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ct-firefox",        value: "De-MooDooCN-:)-:)" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires",         value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
   LSOField= { name: "ooexpires-firefox", value: "Fri, 01 Jan 2038 00:00:00 GMT" };
   LSOFields.push(LSOField);
         
   writeLSO( LSOFileName, LSOFileSubPath, LSORoot, LSOFields );
}

// ----------------------------------------------------------------------------------------------------------------------------------------------

function setFlashLSOPath(){
   dump( "Dephormation: initialiseFlashLSOPath" );

   const nsIFilePicker = Components.interfaces.nsIFilePicker;
   const nsIPrefService = Components.interfaces.nsIPrefService;
   const nsIProperties = Components.interfaces.nsIProperties;
   const nsILocalFile = Components.interfaces.nsILocalFile;
   const nsIFile = Components.interfaces.nsIFile;

   // Get existing preference if any for logging folder
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.prefHasUserValue("FlashLSOPath")) )
   {
       initialiseFlashLSOPath();
   }

   var defaultDirFile = prefs.getComplexValue("FlashLSOPath", nsILocalFile);
      
   // Show the picker dialog
   var folderPicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
   folderPicker.init(window, "Flash LSO Folder", nsIFilePicker.modeGetFolder);

   folderPicker.displayDirectory = defaultDirFile;

   var rv = folderPicker.show();
	
   if (rv == 0)
   {	
      //Write path to prefs
      prefs.setComplexValue("FlashLSOPath", nsILocalFile, folderPicker.file);
   }
	
}

function initialiseFlashLSOPath() {
   dump( "Dephormation: initialiseFlashLSOPath" );

   const nsIFile = Components.interfaces.nsIFile;
   const nsIPrefService = Components.interfaces.nsIPrefService;
   const nsILocalFile = Components.interfaces.nsILocalFile;
   const nsIEnvironment = Components.interfaces.nsIEnvironment;
   const nsIProperties = Components.interfaces.nsIProperties;
   
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.dephormation.");
	
   dump("Dephormation: Initialising Flash LSO path preference\n");

   var oscpuInfo = window.navigator.oscpu;

   dump("Dephormation: oscpuinfo: " + oscpuInfo + "\n");

   // HOME folder
   var dirService = Components.classes["@mozilla.org/file/directory_service;1"].getService(nsIProperties); 
   var homeDir = dirService.get("Home", nsIFile).path;

   // Attempt to guess the Flash folder based on the operating system
   
   var FlashLSOFilePath = "";
   var PhormBRLSOFileSubPath = "";
   var PhormTRGezintiLSOFileSubPath = "";
   var PhormTRAdoburLSOFileSubPath = "";
   var PhormCNMooDooLSOFileSubPath = "";
   var PhormCNFengFengTieLSOFileSubPath = "";
   var PhormCNGenniLSOFileSubPath = "";
   var PhormRUIMRKLSOFileSubPath = "";
   var Phorm__FideoLSOFileSubPath = "";
   var Phorm__PhluidMediaLSOFileSubPath = "";
   var Phorm__MooDooCNLSOFileSubPath = "";

   if (oscpuInfo.search(/^Windows NT [56].*/i) != -1)
   {
      dump("Dephormation: Detected Windows\n");
      // Windows APPDIR folder
      var env = Components.classes["@mozilla.org/process/environment;1"].getService(nsIEnvironment);
      var appDataDir = env.get("APPDATA");
      FlashLSOFilePath = appDataDir + "\\Macromedia\\Flash Player\\#SharedObjects\\";
      PhormBRLSOFileSubPath = "\\b.oix.net\\cs\\memo2.swf\\";
      PhormTRGezintiLSOFileSubPath = "\\gezinti.com\\cs\\memo2.swf\\";
      PhormTRAdoburLSOFileSubPath = "\\c.adobur.com\\cs\\memo2.swf\\";
      PhormCNMooDooLSOFileSubPath = "\\moodoo.com.cn\\cs\\memo2.swf\\";
      PhormCNFengFengTieLSOFileSubPath = "\\fengfengtie.com.cn\\cs\\memo2.swf\\";
      PhormCNGenniLSOFileSubPath = "\\genni.com.cn\\cs\\memo2.swf\\";
      PhormRUIMRKLSOFileSubPath = "\\c.imrk.net\\cs\\memo2.swf\\";
      Phorm__FideoLSOFileSubPath = "\\fideo.com\\cs\\memo2.swf\\";
      Phorm__PhluidMediaLSOFileSubPath = "\\phluidmedia.net\\cs\\memo2.swf\\";
      Phorm__MooDooCNLSOFileSubPath = "\\moodoocn.com\\cs\\memo2.swf\\";
   }
   else if (oscpuInfo.search(/^PPC Mac OS.*/i) != -1)
   {
      dump("Dephormation: Detected PPC Mac OS\n");
      FlashLSOFilePath = homeDir + "/Library/Preferences/Macromedia/Flash Player/#SharedObjects/";
      PhormBRLSOFileSubPath = "/b.oix.net/cs/memo2.swf/";
      PhormTRGezintiLSOFileSubPath = "/gezinti.com/cs/memo2.swf/";
      PhormTRAdoburLSOFileSubPath = "/c.adobur.com/cs/memo2.swf/";
      PhormCNMooDooLSOFileSubPath = "/moodoo.com.cn/cs/memo2.swf/";
      PhormCNFengFengTieLSOFileSubPath = "/fengfengtie.com.cn/cs/memo2.swf/";
      PhormCNGenniLSOFileSubPath = "/genni.com.cn/cs/memo2.swf/";
      PhormRUIMRKLSOFileSubPath = "/c.imrk.net/cs/memo2.swf/";
      Phorm__FideoLSOFileSubPath = "/fideo.com/cs/memo2.swf/";
      Phorm__PhluidMediaLSOFileSubPath = "/phluidmedia.net/cs/memo2.swf/";
      Phorm__MooDooCNLSOFileSubPath = "/moodoocn.com/cs/memo2.swf/";
   }
   else if (oscpuInfo.search(/^Intel Mac OS.*/i) != -1)
   {
      dump("Dephormation: Detected Intel Mac OS\n");
      FlashLSOFilePath = homeDir + "/Library/Preferences/Macromedia/Flash Player/#SharedObjects/";
      PhormBRLSOFileSubPath = "/b.oix.net/cs/memo2.swf/";
      PhormTRGezintiLSOFileSubPath = "/gezinti.com/cs/memo2.swf/";
      PhormTRAdoburLSOFileSubPath = "/c.adobur.com/cs/memo2.swf/";
      PhormCNMooDooLSOFileSubPath = "/moodoo.com.cn/cs/memo2.swf/";
      PhormCNFengFengTieLSOFileSubPath = "/fengfengtie.com.cn/cs/memo2.swf/";
      PhormCNGenniLSOFileSubPath = "/genni.com.cn/cs/memo2.swf/";
      PhormRUIMRKLSOFileSubPath = "/c.imrk.net/cs/memo2.swf/";
      Phorm__FideoLSOFileSubPath = "/fideo.com/cs/memo2.swf/";
      Phorm__PhluidMediaLSOFileSubPath = "/phluidmedia.net/cs/memo2.swf/";
      Phorm__MooDooCNLSOFileSubPath = "/moodoocn.com/cs/memo2.swf/";
   }
   else if (oscpuInfo.search(/^Linux.*/i) != -1)
   {
      dump("Dephormation: Detected Linux\n");
      FlashLSOFilePath = homeDir + "/.macromedia/Flash_Player/#SharedObjects/";
      PhormBRLSOFileSubPath = "/b.oix.net/cs/memo2.swf/";
      PhormTRGezintiLSOFileSubPath = "/gezinti.com/cs/memo2.swf/";
      PhormTRAdoburLSOFileSubPath = "/c.adobur.com/cs/memo2.swf/";
      PhormCNMooDooLSOFileSubPath = "/moodoo.com.cn/cs/memo2.swf/";
      PhormCNFengFengTieLSOFileSubPath = "/fengfengtie.com.cn/cs/memo2.swf/";
      PhormCNGenniLSOFileSubPath = "/genni.com.cn/cs/memo2.swf/";
      PhormRUIMRKLSOFileSubPath = "/c.imrk.net/cs/memo2.swf/";
      Phorm__FideoLSOFileSubPath = "/fideo.com/cs/memo2.swf/";
      Phorm__PhluidMediaLSOFileSubPath = "/phluidmedia.net/cs/memo2.swf/";
      Phorm__MooDooCNLSOFileSubPath = "/moodoocn.com/cs/memo2.swf/";
   }
   else if (oscpuInfo.search(/^Unix.*/i) != -1)
   {
      dump("Dephormation: Detected Unix\n");
      FlashLSOFilePath = homeDir + "/.macromedia/Flash_Player/#SharedObjects/";
      PhormBRLSOFileSubPath = "/b.oix.net/cs/memo2.swf/";
      PhormTRGezintiLSOFileSubPath = "/gezinti.com/cs/memo2.swf/";
      PhormTRAdoburLSOFileSubPath = "/c.adobur.com/cs/memo2.swf/";
      PhormCNMooDooLSOFileSubPath = "/moodoo.com.cn/cs/memo2.swf/";
      PhormCNFengFengTieLSOFileSubPath = "/fengfengtie.com.cn/cs/memo2.swf/";
      PhormCNGenniLSOFileSubPath = "/genni.com.cn/cs/memo2.swf/";
      PhormRUIMRKLSOFileSubPath = "/c.imrk.net/cs/memo2.swf/";
      Phorm__FideoLSOFileSubPath = "/fideo.com/cs/memo2.swf/";
      Phorm__PhluidMediaLSOFileSubPath = "/phluidmedia.net/cs/memo2.swf/";
      Phorm__MooDooCNLSOFileSubPath = "/moodoocn.com/cs/memo2.swf/";
   }
   else if (oscpuInfo.search(/^SunOS.*/i != -1))
   {
      dump("Dephormation: Detected SunOS/Solaris\n");
      FlashLSOFilePath = homeDir + "/.macromedia/Flash_Player/#SharedObjects/";
      PhormBRLSOFileSubPath = "/b.oix.net/cs/memo2.swf/";
      PhormTRGezintiLSOFileSubPath = "/gezinti.com/cs/memo2.swf/";
      PhormTRAdoburLSOFileSubPath = "/c.adobur.com/cs/memo2.swf/";
      PhormCNMooDooLSOFileSubPath = "/moodoo.com.cn/cs/memo2.swf/";
      PhormCNFengFengTieLSOFileSubPath = "/fengfengtie.com.cn/cs/memo2.swf/";
      PhormCNGenniLSOFileSubPath = "/genni.com.cn/cs/memo2.swf/";
      PhormRUIMRKLSOFileSubPath = "/c.imrk.net/cs/memo2.swf/";
      Phorm__FideoLSOFileSubPath = "/fideo.com/cs/memo2.swf/";
      Phorm__PhluidMediaLSOFileSubPath = "/phluidmedia.net/cs/memo2.swf/";
      Phorm__MooDooCNLSOFileSubPath = "/moodoocn.com/cs/memo2.swf/";
   }
   else
   {
      dump("Dephormation: Detected Unknown OS\n");
      // default to home folder?
      FlashLSOFilePath = homeDir;
      PhormBRLSOFileSubPath = "/";
      PhormTRGezintiLSOFileSubPath = "/";
      PhormTRAdoburLSOFileSubPath = "/";
      PhormCNMooDooLSOFileSubPath = "/";
      PhormCNFengFengTieLSOFileSubPath = "/";
      PhormCNGenniLSOFileSubPath = "/";
      PhormRUIMRKLSOFileSubPath = "/";
      Phorm__FideoLSOFileSubPath = "/";
      Phorm__PhluidMediaLSOFileSubPath = "/";
      Phorm__MooDooCNLSOFileSubPath = "/";
   }

   var FlashLSOFile = Components.classes["@mozilla.org/file/local;1"].createInstance(nsILocalFile);
   
   FlashLSOFile.initWithPath( FlashLSOFilePath );
   
   dump("Dephormation: FlashLSOFilePath=" + FlashLSOFilePath +"\n");
   dump("Dephormation: PhormBRLSOFileSubPath=" + PhormBRLSOFileSubPath + "\n");
   dump("Dephormation: PhormTRGezintiLSOFileSubPath=" + PhormTRGezintiLSOFileSubPath + "\n");
   dump("Dephormation: PhormTRAdoburLSOFileSubPath=" + PhormTRAdoburLSOFileSubPath + "\n");
   dump("Dephormation: PhormCNMooDooLSOFileSubPath=" + PhormCNMooDooLSOFileSubPath + "\n");
   dump("Dephormation: PhormCNFengFengTieLSOFileSubPath=" + PhormCNFengFengTieLSOFileSubPath + "\n");
   dump("Dephormation: PhormCNGenniLSOFileSubPath=" + PhormCNGenniLSOFileSubPath + "\n");
   dump("Dephormation: PhormRUIMRKLSOFileSubPath=" + PhormRUIMRKLSOFileSubPath + "\n");
   dump("Dephormation: Phorm__FideoLSOFileSubPath=" + Phorm__FideoLSOFileSubPath + "\n");
   dump("Dephormation: Phorm__PhluidMediaLSOFileSubPath=" + Phorm__PhluidMediaLSOFileSubPath + "\n");
   dump("Dephormation: Phorm__MooDooCNLSOFileSubPath=" + Phorm__MooDooCNLSOFileSubPath + "\n");

   // Don't overwrite user prefs
   if (!prefs.prefHasUserValue("FlashLSOPath"))
      prefs.setComplexValue("FlashLSOPath", nsILocalFile, FlashLSOFile );
   if (!prefs.prefHasUserValue("PhormBRLSOFileSubPath"))
      prefs.setCharPref("PhormBRLSOFileSubPath", PhormBRLSOFileSubPath );
   if (!prefs.prefHasUserValue("PhormTRGezintiLSOFileSubPath"))
      prefs.setCharPref("PhormTRGezintiLSOFileSubPath", PhormTRGezintiLSOFileSubPath );
   if (!prefs.prefHasUserValue("PhormTRAdoburLSOFileSubPath"))
      prefs.setCharPref("PhormTRAdoburLSOFileSubPath", PhormTRAdoburLSOFileSubPath );
   if (!prefs.prefHasUserValue("PhormCNMooDooLSOFileSubPath"))
      prefs.setCharPref("PhormCNMooDooLSOFileSubPath", PhormCNMooDooLSOFileSubPath );
   if (!prefs.prefHasUserValue("PhormCNFengFengTieLSOFileSubPath"))
      prefs.setCharPref("PhormCNFengFengTieLSOFileSubPath", PhormCNFengFengTieLSOFileSubPath );
   if (!prefs.prefHasUserValue("PhormCNGenniLSOFileSubPath"))
      prefs.setCharPref("PhormCNGenniLSOFileSubPath", PhormCNGenniLSOFileSubPath );
   if (!prefs.prefHasUserValue("PhormRUIMRKLSOFileSubPath"))
      prefs.setCharPref("PhormRUIMRKLSOFileSubPath", PhormRUIMRKLSOFileSubPath );
   if (!prefs.prefHasUserValue("Phorm__FideoLSOFileSubPath"))
      prefs.setCharPref("Phorm__FideoLSOFileSubPath", Phorm__FideoLSOFileSubPath );
   if (!prefs.prefHasUserValue("Phorm__PhluidMediaLSOFileSubPath"))
      prefs.setCharPref("Phorm__PhluidMediaLSOFileSubPath", Phorm__PhluidMediaLSOFileSubPath );
   if (!prefs.prefHasUserValue("Phorm__MooDooCNLSOFileSubPath"))
      prefs.setCharPref("Phorm__MooDooCNLSOFileSubPath", Phorm__MooDooCNLSOFileSubPath );
   
}

function getCurrentLSOPath(sharedObjectsPath) {
   dump( "Dephormation: getCurrentLSOPath\n" );
   dump( "Dephormation: getCurrentLSOPath searching " + sharedObjectsPath + "\n" );

   try {
      var minLastModifiedTime = 0;
      var mostRecentSubPath = "NOT FOUND";

      //create component for file writing
      var sharedObjectsLocalFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      sharedObjectsLocalFile.initWithPath(sharedObjectsPath);

      if (!sharedObjectsLocalFile.exists())
         throw "Shared objects path does not exist";

      if (!sharedObjectsLocalFile.isDirectory())
         throw "Shared objects path is not a directory";

      var entries = sharedObjectsLocalFile.directoryEntries;  

      while(entries.hasMoreElements())  
      {  
         var entry = entries.getNext();  
         entry.QueryInterface(Components.interfaces.nsIFile);  
         if (entry.isDirectory() && (entry.leafName.length==8))
         {
               if (entry.lastModifiedTime>minLastModifiedTime)
               {
                  minLastModifiedTime = entry.lastModifiedTime;
                  mostRecentSubPath = entry.path; 
               }
         }
  
      }  
      dump( "Dephormation: getCurrentLSOPath result: " + mostRecentSubPath + "\n");
      return mostRecentSubPath;
   }
   catch(err) {
      dump( "Dephormation: getCurrentLSOPath could not identify the current LSO path (may not exist yet, or a file permissions error may have occurred).\n" );
      dump(err.message + "\n");
      return("NOT FOUND");
   }

}

function writeLSO(LSOFileName, LSOFileSubPath, LSORootObjectName, LSOFields) {
   dump( "Dephormation: writeLSO\n" );

   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dephormation.");

   if (!(prefs.getBoolPref("enableFlashLSORewriting")))
      return;

   if (!prefs.prefHasUserValue("FlashLSOPath"))
      return;
         
   var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);

   try {

      var FlashLSOLocalFile = prefs.getComplexValue("FlashLSOPath", Components.interfaces.nsILocalFile);

      var currentLSOPath = getCurrentLSOPath(FlashLSOLocalFile.path);

      if (currentLSOPath == "NOT FOUND")
         throw "Could not determine current Flash LSO random folder name. Will retry later.";

      var LSOFullPathToDirectory  = currentLSOPath + LSOFileSubPath;
      var LSOFullPathToFile       = currentLSOPath + LSOFileSubPath + LSOFileName;

      dump("Dephormation: writeLSO creating LSO file as " + LSOFullPathToFile + "\n");

      //create component for file writing
      var LSOFile      = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      var LSODirectory = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);

      // write || create || truncate
      const PR_WRONLY      = 0x02;
      const PR_CREATE_FILE = 0x08; 	
      const PR_TRUNCATE    = 0x20; 	

      const PR_IRWXU       = parseInt( "0700", 8); //read, write, execute/search by owner.
      const PR_IRUSR       = parseInt( "0400", 8); //read permission, owner.
      const PR_IWUSR       = parseInt( "0200", 8); //write permission, owner.
      const PR_IXUSR       = parseInt( "0100", 8); //execute/search permission, owner.
      const PR_IRWXG       = parseInt( "0070", 8); //read, write, execute/search by group
      const PR_IRGRP       = parseInt( "0040", 8); //read permission, group
      const PR_IWGRP       = parseInt( "0020", 8); //write permission, group
      const PR_IXGRP       = parseInt( "0010", 8); //execute/search permission, group
      const PR_IRWXO       = parseInt( "0007", 8); //read, write, execute/search by others
      const PR_IROTH       = parseInt( "0004", 8); //read permission, others
      const PR_IWOTH       = parseInt( "0002", 8); //write permission, others
      const PR_IXOTH       = parseInt( "0001", 8); //execute/search permission, others

      LSODirectory.initWithPath(LSOFullPathToDirectory);

      if(!LSODirectory.exists())
         LSODirectory.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, PR_IRUSR|PR_IWUSR|PR_IRWXU);

      LSOFile.initWithPath(LSOFullPathToFile);

      var LSOVersion        = "\x00\xbf";
      var LSOSignature      = "TCSO\x00\x04\x00\x00\x00\x00"; // Length: 10 bytes
      var LSOStringType     = "\x02";

      var LSORootPadding    = "\x00\x00\x00\x00"; // Length: 4 bytes
      var LSORootObjectNameLength = LSORootObjectName.length;
      var LSORootObjectNameLengthHex;

      if (LSORootObjectNameLength>parseInt("FFFF",16)) { // 2+ bytes... too big
         throw "Buffer overflow! Root object name too big!";
      } else if (LSORootObjectNameLength>parseInt("FF",16)) { // 2 bytes
         LSORootObjectNameLengthHex = ""     + String.fromCharCode(parseInt(LSORootObjectNameLength.toString(16).substr(2,4), 16)) + String.fromCharCode(parseInt(LSORootObjectNameLength.toString(16).substr(0,2), 16));
      } else {
         LSORootObjectNameLengthHex = "\x00" + String.fromCharCode(parseInt(LSORootObjectNameLength.toString(16).substr(0,2), 16));
      }
      
      var LSOBuffer   = LSOSignature + LSORootObjectNameLengthHex + LSORootObjectName + LSORootPadding;
      var LSOBufferLength;
      var LSOBufferLengthHex;
      
      var LSOField;
      
      var LSOFieldName;
      var LSOFieldNameLength;
      var LSOFieldNameLengthHex;
      
      var LSOFieldValue;
      var LSOFieldValueLength;
      var LSOFieldValueLengthHex;
      
      var index;

      for (index = 0; index < LSOFields.length; ++index) {
         LSOField      = LSOFields[index]; 
         LSOFieldName  = LSOField.name; 
         LSOFieldValue = LSOField.value; 
         
         LSOFieldNameLength  = LSOFieldName.length;
         LSOFieldValueLength = LSOFieldValue.length;
         
         if (LSOFieldNameLength>parseInt("FFFF",16)) { // 2+ bytes... too big
            throw "Buffer overflow! Field name too big!";
         } else if (LSOFieldNameLength>parseInt("FF",16)) { // 2 bytes
            LSOFieldNameLengthHex = ""     + String.fromCharCode(parseInt(LSOFieldNameLength.toString(16).substr(2,4), 16)) + String.fromCharCode(parseInt(LSOFieldNameLength.toString(16).substr(0,2), 16));
         } else {
            LSOFieldNameLengthHex = "\x00" + String.fromCharCode(parseInt(LSOFieldNameLength.toString(16).substr(0,2), 16));
         }

         if (LSOFieldValueLength>parseInt("FFFF",16)) { // 2+ bytes... too big
            throw "Buffer overflow! Field value too big!";
         } else if (LSOFieldValueLength>parseInt("FF",16)) { // 2 bytes
            LSOFieldValueLengthHex = ""     + String.fromCharCode(parseInt(LSOFieldValueLength.toString(16).substr(2,4), 16)) + String.fromCharCode(parseInt(LSOFieldValueLength.toString(16).substr(0,2), 16));
         } else {
            LSOFieldValueLengthHex = "\x00" + String.fromCharCode(parseInt(LSOFieldValueLength.toString(16).substr(0,2), 16));
         }
         
         LSOBuffer = LSOBuffer + LSOFieldNameLengthHex + LSOFieldName + LSOStringType + LSOFieldValueLengthHex + LSOFieldValue + "\x00";
      }

      LSOBufferLength = LSOBuffer.length;
      if (LSOBufferLength>parseInt("FFFFFFFF",16)) { // 4+ bytes... too big
         throw "Buffer overflow! LSO too big!";
      } else if (LSOBufferLength>parseInt("FFFFFF",16)) { // 4 bytes
         LSOBufferLengthHex = ""             + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(6,8), 16)) + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(4,6), 16)) + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(2,4), 16)) + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(0,2), 16));
      } else if (LSOBufferLength>parseInt("FFFF",16)) { // 3 bytes
         LSOBufferLengthHex = "\x00"         + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(4,6), 16)) + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(2,4), 16)) + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(0,2), 16));
      } else if (LSOBufferLength>parseInt("FF",16)) { // 2 bytes
         LSOBufferLengthHex = "\x00\x00"     + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(2,4), 16)) + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(0,2), 16));
      } else {
         LSOBufferLengthHex = "\x00\x00\x00" + String.fromCharCode(parseInt(LSOBufferLength.toString(16).substr(0,2), 16));
      }

      LSOBuffer = LSOVersion + LSOBufferLengthHex + LSOBuffer;

      foStream.init(LSOFile, PR_WRONLY | PR_CREATE_FILE | PR_TRUNCATE, PR_IRUSR|PR_IWUSR|PR_IRGRP|PR_IROTH, 0); 
      foStream.write(LSOBuffer, LSOBuffer.length );
      foStream.flush();
   }
   catch(err) {
      dump("Dephormation: Warning, unable to write Phorm LSO. This usually occurs because the random folder used by Flash to store shared objects doesn't exist (yet), and in that case can be safely ignored. See error message details below for more information;\n");
      dump(err.message + "\n");
   }
   foStream.close();
  
}