"use strict";
//Dephormation
// 
//Licence Terms
// 
//1) Dephormation is copyright Peter John
//
//You may;
//
//2) Download and install Dephormation software for personal or commercial use
//
//3) You may use Dephormation software on as many computers as you wish, without charge
//
//4) You may decompile the software, but only to verify the code will perform to specification
//
//You may not;
//
//5) Rebrand or bundle the code, or any part of the code, with any other software product
//
//6) Incorporate the code into a product or service involving Phorm or any other advertising system
//
//Specific Restrictions;
//
//7) Dephormation software is not licenced for use by employees or sub-contractors working for Phorm, BT, Plusnet, TalkTalk, Virgin, Vodafone, BBC, News Corporation, News International, Logica, Experian, Verizon, Facebook, Schillings, Berenberg, Blackrock, Dartley Bank
//
//8) Dephormation software is not licenced for use by employees or sub-contractors working for UK Central Government (including but not limited to the Information Commissioners Office, Home Office, Ministry of Justice, Dept for Business Innovation and Skills, Cabinet Office, Ministry of Defence, Foreign Office, Department for Education).
//
//9) Dephormation software is not licenced for use by employees or sub-contractors working for UK Police forces
// 

function oncommandRadioBlockSpikeOIX() {
   const nsIPrefService = Components.interfaces.nsIPrefService;

   var radioBlockSpikeOIX = document.getElementById("radioBlockSpikeOIX");
   var textSpikeOIXRedirectLocation= document.getElementById("textSpikeOIXRedirectLocation");

   // Get existing preference if any
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.dephormation.");

   if (radioBlockSpikeOIX.value=="blockOIXDomainRequest")
   {
      prefs.setBoolPref("blockOIXDomainRequest", true);
      prefs.setBoolPref("spikeOIXRedirect"     , false);
      textSpikeOIXRedirectLocation.disabled = true;
   }
   else if (radioBlockSpikeOIX.value=="spikeOIXRedirect")
   {
      prefs.setBoolPref("blockOIXDomainRequest", false);
      prefs.setBoolPref("spikeOIXRedirect"     , true);
      textSpikeOIXRedirectLocation.disabled = false;
   }
   else if (radioBlockSpikeOIX.value=="noBlockSpikeOIX")
   {
      prefs.setBoolPref("blockOIXDomainRequest", false);
      prefs.setBoolPref("spikeOIXRedirect"     , false);
      textSpikeOIXRedirectLocation.disabled = true;
   }

}

function populateRadioBlockSpikeOIX() {
   const nsIPrefService = Components.interfaces.nsIPrefService;

   var radioBlockSpikeOIX = document.getElementById("radioBlockSpikeOIX");
   var textSpikeOIXRedirectLocation= document.getElementById("textSpikeOIXRedirectLocation");

   // Get existing preference if any
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.dephormation.");

   if (prefs.getBoolPref("blockOIXDomainRequest"))
   {
      radioBlockSpikeOIX.value="blockOIXDomainRequest";
      textSpikeOIXRedirectLocation.disabled = true;
      prefs.setBoolPref("spikeOIXRedirect", false);
   }
   else if (prefs.getBoolPref("spikeOIXRedirect"))
   {
      radioBlockSpikeOIX.value="spikeOIXRedirect";
      textSpikeOIXRedirectLocation.disabled = false;
      prefs.setBoolPref("blockOIXDomainRequest", false);
   }
   else if (radioBlockSpikeOIX.value=="noBlockSpikeOIX")
   {
      radioBlockSpikeOIX.value="noBlockSpikeOIX";
      textSpikeOIXRedirectLocation.disabled = true;
      prefs.setBoolPref("spikeOIXRedirect", false);
      prefs.setBoolPref("blockOIXDomainRequest", false);
   }

}

function populateFilePaths() {
   const nsIPrefService = Components.interfaces.nsIPrefService;
   const nsILocalFile = Components.interfaces.nsILocalFile;

   var textFlashLSOPath = document.getElementById("textFlashLSOPath");
   var textBrowserActivityLog = document.getElementById("textBrowserActivityLog");

   // Get existing preference if any
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.dephormation.");

   if (prefs.prefHasUserValue("FlashLSOPath") )
   {
      var FlashLSOPathFile = prefs.getComplexValue("FlashLSOPath", nsILocalFile);
      textFlashLSOPath.value = FlashLSOPathFile.path;
   }
   else
   {
      textFlashLSOPath.value = "(not set)";
   }

   if (prefs.prefHasUserValue("browserActivityLogPath") )
   {
      var browserActivityLogPathFile = prefs.getComplexValue("browserActivityLogPath", nsILocalFile);
      textBrowserActivityLog.value = browserActivityLogPathFile.path;
   }
   else
   {
      textBrowserActivityLog.value = "(not set)";
   }

}

function resetDefaults() {
   const nsIPrefService = Components.interfaces.nsIPrefService;

   // Get existing preference if any
   var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.dephormation.");

   try{ prefs.clearUserPref("disablePhorm");                  } catch(e) {}
   try{ prefs.clearUserPref("showCookieSettingAlert");        } catch(e) {}
   try{ prefs.clearUserPref("showStartupAlert");              } catch(e) {}
   try{ prefs.clearUserPref("randomizePhormUID");             } catch(e) {}
   try{ prefs.clearUserPref("showOIXDomainAlert");            } catch(e) {}
   try{ prefs.clearUserPref("spikeOIXRedirect");              } catch(e) {}
   try{ prefs.clearUserPref("spikeOIXRedirectLocation");      } catch(e) {}
   try{ prefs.clearUserPref("blockOIXDomainRequest");         } catch(e) {}
   try{ prefs.clearUserPref("showNonOIXDomainAlert");         } catch(e) {}
   try{ prefs.clearUserPref("enableBrowserActivityLog");      } catch(e) {}
   try{ prefs.clearUserPref("enableFlashLSORewriting");       } catch(e) {}
   try{ prefs.clearUserPref("showOperatorPortalDomainAlert"); } catch(e) {}
   try{ prefs.clearUserPref("showOCSLabDomainAlert");         } catch(e) {}
   try{ prefs.clearUserPref("FlashLSOPath");                  } catch(e) {}
   try{ prefs.clearUserPref("browserActivityLogPath");        } catch(e) {}
   try{ prefs.clearUserPref("blockPhormPartners");            } catch(e) {}

   initialiseFlashLSOPath();
   initialiseBrowserActivityLogPath();

}